/****************************************************************************
*
* 51BATON.H
*
* PROGRAMMER : Gibby
*    VERSION : 00.00
*    CREATED : 20/08/98
*   MODIFIED : 20/08/98
*       TABS : 5
*
* DESCRIPTION
*	Header file for 51BATON.C
*
*****************************************************************************/

#ifndef _51BATON_H
#define _51BATON_H

#ifdef __cplusplus
extern "C" {
#endif

/*---------------------------------------------------------------------------
 *	Import Headers
\*--------------------------------------------------------------------------*/

#ifdef PSX_VERSION
#include "../spec_psx/typedefs.h"
#else
#include "..\specific\stypes.h"
#endif

#include "items.h"

/*---------------------------------------------------------------------------
 *	Prototypes
\*--------------------------------------------------------------------------*/
//#define NO_RELOC_51BATON
#if defined(PSX_VERSION) && defined(RELOC) && !defined(NO_RELOC_51BATON)


#define InitialiseBaton ((VOIDFUNCSINT16*) Baddie2Ptr[0])
#define BatonControl ((VOIDFUNCSINT16*) Baddie2Ptr[1])

#else

void InitialiseBaton(sint16 item_number);
void BatonControl(sint16 item_number);

#endif

#ifdef __cplusplus
}
#endif

#endif
