/****************************************************************************
*
* 51CIVVY.H
*
* PROGRAMMER : Gibby
*    VERSION : 00.00
*    CREATED : 20/08/98
*   MODIFIED : 20/08/98
*       TABS : 5
*
* DESCRIPTION
*	Header file for 51CIVVY.C
*
*****************************************************************************/

#ifndef _51CIVVY_H
#define _51CIVVY_H

#ifdef __cplusplus
extern "C" {
#endif

/*---------------------------------------------------------------------------
 *	Import Headers
\*--------------------------------------------------------------------------*/

#ifdef PSX_VERSION
#include "../spec_psx/typedefs.h"
#else
#include "..\specific\stypes.h"
#endif

#include "items.h"

/*---------------------------------------------------------------------------
 *	Prototypes
\*--------------------------------------------------------------------------*/
//#define NO_RELOC_51CIVVY
#if defined(PSX_VERSION) && defined(RELOC) && !defined(NO_RELOC_51CIVVY)

#define InitialiseCivvy ((VOIDFUNCSINT16*) Baddie2Ptr[0])
#define CivvyControl ((VOIDFUNCSINT16*) Baddie2Ptr[1])
#define ControlElectricFence ((VOIDFUNCSINT16*) Baddie2Ptr[2])

#else

void InitialiseCivvy(sint16 item_number);
void CivvyControl(sint16 item_number);
void ControlElectricFence(sint16 item_number);

#endif

#ifdef __cplusplus
}
#endif

#endif
