/****************************************************************************
*
* 51LASER.H
*
* PROGRAMMER : Gibby
*    VERSION : 00.00
*    CREATED : 23/08/98
*   MODIFIED : 23/08/98
*       TABS : 5
*
* DESCRIPTION
*	Header file for 51LASER.C
*
*****************************************************************************/

#ifndef _51LASER_H
#define _51LASER_H

#ifdef __cplusplus
extern "C" {
#endif

/*---------------------------------------------------------------------------
 *	Import Headers
\*--------------------------------------------------------------------------*/

#ifdef PSX_VERSION
#include "../spec_psx/typedefs.h"
#else
#include "..\specific\stypes.h"
#endif

#include "items.h"

/*---------------------------------------------------------------------------
 *	Prototypes
\*--------------------------------------------------------------------------*/

//#define NO_RELOC_51LASER
#if defined(PSX_VERSION) && defined(RELOC) && !defined(NO_RELOC_51LASER)

//typedef void (LASER51FUNC1)(long, long, long, long);

#define ControlArea51Laser ((VOIDFUNCSINT16*) Effect3Ptr[0])
#define InitialiseArea51Laser ((VOIDFUNCSINT16*) Effect3Ptr[1])

#else

void ControlArea51Laser(sint16 item_number);
void InitialiseArea51Laser(sint16 item_number);

#endif

#ifdef __cplusplus
}
#endif

#endif
