/****************************************************************************
*
* ARMYSMG.H
*
* PROGRAMMER : Gibby
*    VERSION : 00.00
*    CREATED : 20/08/98
*   MODIFIED : 20/08/98
*       TABS : 5
*
* DESCRIPTION
*	Header file for ARMYSMG.C
*
*****************************************************************************/

#ifndef _ARMYSMG_H
#define _ARMYSMG_H

#ifdef __cplusplus
extern "C" {
#endif

/*---------------------------------------------------------------------------
 *	Import Headers
\*--------------------------------------------------------------------------*/

#ifdef PSX_VERSION
#include "../spec_psx/typedefs.h"
#else
#include "..\specific\stypes.h"
#endif

#include "items.h"

/*---------------------------------------------------------------------------
 *	Prototypes
\*--------------------------------------------------------------------------*/
//#define NO_RELOC_ARMYSMG
#if defined(PSX_VERSION) && defined(RELOC) && !defined(NO_RELOC_ARMYSMG)


#define InitialiseArmySMG ((VOIDFUNCSINT16*) Baddie4Ptr[0])
#define ArmySMGControl ((VOIDFUNCSINT16*) Baddie4Ptr[1])

#else

void InitialiseArmySMG(sint16 item_number);
void ArmySMGControl(sint16 item_number);

#endif

#ifdef __cplusplus
}
#endif

#endif
