/****************************************************************************
*
* AUTOGUN.H
*
* PROGRAMMER : Gibby
*    VERSION : 00.00
*    CREATED : 20/08/98
*   MODIFIED : 20/08/98
*       TABS : 5
*
* DESCRIPTION
*	Header file for AUTOGUN.C
*
*****************************************************************************/

#ifndef _AUTOGUN_H
#define _AUTOGUN_H

#ifdef __cplusplus
extern "C" {
#endif

/*---------------------------------------------------------------------------
 *	Import Headers
\*--------------------------------------------------------------------------*/

#ifdef PSX_VERSION
#include "../spec_psx/typedefs.h"
#else
#include "..\specific\stypes.h"
#endif

#include "items.h"

/*---------------------------------------------------------------------------
 *	Prototypes
\*--------------------------------------------------------------------------*/
//#define NO_RELOC_AUTOGUN
#if defined(PSX_VERSION) && defined(RELOC) && !defined(NO_RELOC_AUTOGUN)

#define InitialiseAutogun ((VOIDFUNCSINT16*) Baddie7Ptr[0])
#define AutogunControl ((VOIDFUNCSINT16*) Baddie7Ptr[1])

#else

void InitialiseAutogun(sint16 item_number);
void AutogunControl(sint16 item_number);

#endif

#ifdef __cplusplus
}
#endif

#endif
