/****************************************************************************
*
* BIRD.H
*
* PROGRAMMER : Chris
*    VERSION : 00.00
*    CREATED : 01/06/98
*   MODIFIED : 01/06/98
*       TABS : 5
*
* DESCRIPTION
*	Header file for BIRD.C
*
*****************************************************************************/

#ifndef _BIRD_H
#define _BIRD_H

#ifdef __cplusplus
extern "C" {
#endif

/*---------------------------------------------------------------------------
 *	Import Headers
\*--------------------------------------------------------------------------*/

#ifdef PSX_VERSION
#include "../spec_psx/typedefs.h"
#else
#include "..\specific\stypes.h"
#endif

/*---------------------------------------------------------------------------
 *	Prototypes
\*--------------------------------------------------------------------------*/
//#define NO_RELOC_BIRD

#if defined(PSX_VERSION) && defined(RELOC) && !defined(NO_RELOC_BIRD)

#define InitialiseVulture ((VOIDFUNCSINT16 *)Baddie1Ptr[0])
#define VultureControl ((VOIDFUNCSINT16 *)Baddie1Ptr[1])

#else

extern void InitialiseVulture(sint16 item_number);
extern void VultureControl(sint16 item_number);

#endif

#ifdef __cplusplus
}
#endif

#endif
