/****************************************************************************
*
* CLAWMUTE.H
*
* PROGRAMMER : Tom
*    VERSION : 00.00
*    CREATED : 23/08/98
*   MODIFIED : 23/08/98
*       TABS : 5
*
* DESCRIPTION
*	Header file for CLAWMUTE.C
*
*****************************************************************************/

#ifndef _CLAWMUTE_H
#define _CLAWMUTE_H

#ifdef __cplusplus
extern "C" {
#endif

/*---------------------------------------------------------------------------
 *	Import Headers
\*--------------------------------------------------------------------------*/

#ifdef PSX_VERSION
#include "../spec_psx/typedefs.h"
#else
#include "..\specific\stypes.h"
#endif

#include "items.h"

/*---------------------------------------------------------------------------
 *	Prototypes
\*--------------------------------------------------------------------------*/
//#define NO_RELOC_CLAWMUTE
#if defined(PSX_VERSION) && defined(RELOC)&& !defined(NO_RELOC_CLAWMUTE)


#define ClawmuteControl	((VOIDFUNCSINT16 *)Baddie3Ptr[0])
#define ControlClawmutePlasmaBall	((VOIDFUNCSINT16 *)Baddie3Ptr[1])

#else

extern void ClawmuteControl(sint16 item_number);
extern void ControlClawmutePlasmaBall(sint16 fx_number);

#endif

#ifdef __cplusplus
}
#endif

#endif
