/****************************************************************************
*
* DOG.H
*
* PROGRAMMER : Chris
*    VERSION : 00.00
*    CREATED : 16/07/98
*   MODIFIED : 16/07/98
*       TABS : 5
*
* DESCRIPTION
*	Header file for DOG.C
*
*****************************************************************************/

#ifndef _DOG_H
#define _DOG_H

#ifdef __cplusplus
extern "C" {
#endif

/*---------------------------------------------------------------------------
 *	Import Headers
\*--------------------------------------------------------------------------*/

#ifdef PSX_VERSION
#include "../spec_psx/typedefs.h"
#else
#include "..\specific\stypes.h"
#endif

/*---------------------------------------------------------------------------
 *	Prototypes
\*--------------------------------------------------------------------------*/

#if defined(PSX_VERSION) && defined(RELOC)

#define InitialiseDog	((VOIDFUNCSINT16 *)Baddie1Ptr[0])
#define DogControl 		((VOIDFUNCSINT16 *)Baddie1Ptr[1])

#else

extern void InitialiseDog(sint16 item_number);
extern void DogControl(sint16 item_number);

#endif

#ifdef __cplusplus
}
#endif

#endif
