/****************************************************************************
*
* FLAMER.H
*
* PROGRAMMER : Gibby
*    VERSION : 00.00
*    CREATED : 20/08/98
*   MODIFIED : 20/08/98
*       TABS : 5
*
* DESCRIPTION
*	Header file for FLAMER.C
*
*****************************************************************************/

#ifndef _FLAMER_H
#define _FLAMER_H

#ifdef __cplusplus
extern "C" {
#endif

/*---------------------------------------------------------------------------
 *	Import Headers
\*--------------------------------------------------------------------------*/

#ifdef PSX_VERSION
#include "../spec_psx/typedefs.h"
#else
#include "..\specific\stypes.h"
#endif

/*---------------------------------------------------------------------------
 *	Prototypes
\*--------------------------------------------------------------------------*/
//#define NO_RELOC_FLAMER
#if defined(PSX_VERSION) && defined(RELOC) && !defined(NO_RELOC_FLAMER)


typedef void (FLAMERFUNC)(long, long, long, long, long, long, long);

#define FlamerControl	((VOIDFUNCSINT16 *)Baddie3Ptr)

#else

extern void FlamerControl(sint16 item_number);

#endif

#ifdef __cplusplus
}
#endif

#endif
