/****************************************************************************
*
* FOOTPRNT.H
*
* PROGRAMMER : Chris
*    VERSION : 00.00
*    CREATED : 02/07/98
*   MODIFIED : 02/07/98
*       TABS : 5
*
* DESCRIPTION
*	Header file for FOOTPRNT.C
*
*****************************************************************************/

#ifndef _FOOTPRNT_H
#define _FOOTPRNT_H

#ifdef __cplusplus
extern "C" {
#endif

/*---------------------------------------------------------------------------
 *	Import Headers
\*--------------------------------------------------------------------------*/

#ifdef PSX_VERSION
#include "../spec_psx/typedefs.h"
#else
#include "..\specific\stypes.h"
#endif

#include "items.h"

/*---------------------------------------------------------------------------
 *	Constants
\*--------------------------------------------------------------------------*/

#define MAX_FOOTPRINTS	32

/*---------------------------------------------------------------------------
 *	Type Definitions
\*--------------------------------------------------------------------------*/

typedef struct {
	sint32	x, y, z;
	sint16	YRot;
	sint16	Active;
}FOOTPRINT;

/*---------------------------------------------------------------------------
 *	Prototypes
\*--------------------------------------------------------------------------*/

extern void InitFootPrints();
extern void AddFootprint(ITEM_INFO *item);
extern void S_DrawFootPrints();

extern int FootPrintNum;
extern FOOTPRINT FootPrint[MAX_FOOTPRINTS];


#ifdef __cplusplus
}
#endif

#endif
