/****************************************************************************
*
* LARACLIMB.H
*
* PROGRAMMER : Chris
*    VERSION : 00.00
*    CREATED : 03/06/98
*   MODIFIED : 03/06/98
*       TABS : 5
*
* DESCRIPTION
*	Header file for LARACLIMB.C
*
*****************************************************************************/

#ifndef _LARACLIMB_H
#define _LARACLIMB_H

#ifdef __cplusplus
extern "C" {
#endif

/*---------------------------------------------------------------------------
 *	Import Headers
\*--------------------------------------------------------------------------*/

#include "items.h"
#include "collide.h"

/*---------------------------------------------------------------------------
 *	Constants
\*--------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------
 *	Type Definitions
\*--------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------
 *	Prototypes
\*--------------------------------------------------------------------------*/

extern char *clmb_txt[];

extern int LaraTestClimbPos(ITEM_INFO *item, int front, int right, int origin, int height, int *shift);

#if 0
extern void lara_as_climbleft(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_climbleft(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_as_climbright(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_climbright(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_as_climbstnc(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_climbstnc(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_as_climbing(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_climbing(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_as_climbend(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_climbend(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_as_climbdown(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_climbdown(ITEM_INFO *item, COLL_INFO *coll);
#endif

#ifdef __cplusplus
}
#endif

#endif
