/****************************************************************************
*
* LARAFUNC.H
*
* PROGRAMMER : Chris
*    VERSION : 00.00
*    CREATED : 03/06/98
*   MODIFIED : 03/06/98
*       TABS : 5
*
* DESCRIPTION
*	Lara animation functions
*
*****************************************************************************/

#ifndef _LARAFUNC_H
#define _LARAFUNC_H

#ifdef __cplusplus
extern "C" {
#endif

/*---------------------------------------------------------------------------
 *	Import Headers
\*--------------------------------------------------------------------------*/

#include "items.h"
#include "collide.h"

/*---------------------------------------------------------------------------
 *	Prototypes
\*--------------------------------------------------------------------------*/

extern void lara_void_func(ITEM_INFO *item, COLL_INFO *coll);

extern void lara_as_duck(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_duck(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_as_duckroll(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_duckroll(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_as_dash(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_dash(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_as_dashdive(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_dashdive(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_as_monkeyswing(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_monkeyswing(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_as_monkeyl(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_monkeyl(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_as_monkeyr(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_monkeyr(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_as_monkey180(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_monkey180(ITEM_INFO *item, COLL_INFO *coll);

extern void lara_as_all4s(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_all4s(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_as_crawl(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_crawl(ITEM_INFO *item, COLL_INFO *coll);

extern void lara_as_crawlb(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_crawlb(ITEM_INFO *item, COLL_INFO *coll);

extern void lara_col_crawl2hang(ITEM_INFO *item, COLL_INFO *coll);


extern void lara_col_vault(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_as_hang2(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_hang2(ITEM_INFO *item, COLL_INFO *coll);

extern void lara_as_hangturnl(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_as_hangturnr(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_as_all4turnl(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_as_all4turnr(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_hangturnlr(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_all4turnl(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_all4turnr(ITEM_INFO *item, COLL_INFO *coll);

extern void lara_as_link(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_as_swim(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_as_glide(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_as_surftread(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_as_surfswim(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_as_dive(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_as_stop(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_as_walk(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_as_run(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_as_upjump(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_as_forwardjump(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_as_pose(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_as_fastback(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_as_turn_r(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_as_turn_l(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_as_death(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_as_fastfall(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_as_hang(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_as_reach(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_as_splat(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_as_tread(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_as_land(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_as_compress(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_as_back(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_as_null(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_as_fastturn(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_as_stepright(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_as_stepleft(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_as_roll2(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_as_slide(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_as_backjump(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_as_rightjump(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_as_leftjump(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_as_upjump(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_as_fallback(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_as_hangleft(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_as_hangright(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_as_climbleft(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_as_climbright(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_as_slideback(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_as_pushblock(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_as_pullblock(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_as_ppready(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_as_pickup(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_as_switchon(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_as_switchoff(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_as_usekey(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_as_usepuzzle(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_as_uwdeath(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_as_roll(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_as_special(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_as_surfback(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_as_surfleft(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_as_surfright(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_as_usemidas(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_as_diemidas(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_as_swandive(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_as_fastdive(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_as_gymnast(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_as_waterout(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_as_climbstnc(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_as_climbing(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_as_climbend(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_as_climbdown(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_as_laratest1(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_as_laratest2(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_as_laratest3(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_as_wade(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_as_waterroll(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_as_pickupflare(ITEM_INFO *item, COLL_INFO *col);
extern void lara_as_twist(ITEM_INFO *item, COLL_INFO *col);
extern void lara_as_kick(ITEM_INFO *item, COLL_INFO *col);
extern void lara_as_deathslide(ITEM_INFO *item, COLL_INFO *col);

extern void extra_as_breath(ITEM_INFO *item, COLL_INFO *col);
extern void extra_as_plunger(ITEM_INFO *item, COLL_INFO *col);
extern void extra_as_yetikill(ITEM_INFO *item, COLL_INFO *col);
extern void extra_as_sharkkill(ITEM_INFO *item, COLL_INFO *col);
extern void extra_as_airlock(ITEM_INFO *item, COLL_INFO *col);
extern void extra_as_gongbong(ITEM_INFO *item, COLL_INFO *col);
extern void extra_as_dinokill(ITEM_INFO *item, COLL_INFO *col);
extern void extra_as_pulldagger(ITEM_INFO *item, COLL_INFO *col);
extern void extra_as_startanim(ITEM_INFO *item, COLL_INFO *col);
extern void extra_as_starthouse(ITEM_INFO *item, COLL_INFO *col);
extern void extra_as_finalanim(ITEM_INFO *item, COLL_INFO *col);
extern void extra_as_trainkill(ITEM_INFO *item, COLL_INFO *col);
extern void extra_as_rapidsdrown(ITEM_INFO *item, COLL_INFO *col);

extern void lara_col_link(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_walk(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_run(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_stop(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_forwardjump(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_pose(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_fastback(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_turn_r(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_turn_l(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_death(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_fastfall(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_hang(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_reach(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_splat(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_tread(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_land(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_compress(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_back(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_swim(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_glide(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_null(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_fastturn(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_stepright(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_stepleft(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_roll2(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_slide(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_backjump(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_rightjump(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_leftjump(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_upjump(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_fallback(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_hangleft(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_hangright(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_climbleft(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_climbright(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_slideback(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_surftread(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_surfswim(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_dive(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_pushblock(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_pullblock(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_ppready(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_pickup(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_switchon(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_switchoff(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_usekey(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_usepuzzle(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_uwdeath(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_roll(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_special(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_surfback(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_surfleft(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_surfright(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_usemidas(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_diemidas(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_swandive(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_fastdive(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_gymnast(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_waterout(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_climbstnc(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_climbing(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_climbend(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_climbdown(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_laratest1(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_laratest2(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_laratest3(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_wade(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_waterroll(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_twist(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_kick(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_deathslide(ITEM_INFO *item, COLL_INFO *coll);

extern void lara_default_col(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_jumper(ITEM_INFO *item, COLL_INFO *coll);

#ifdef __cplusplus
}
#endif

#endif

