/****************************************************************************
*
* LONDSEC.H
*
* PROGRAMMER : Tom
*    VERSION : 00.00
*    CREATED : 23/08/98
*   MODIFIED : 23/08/98
*       TABS : 5
*
* DESCRIPTION
*	Header file for LONDSEC.C
*
*****************************************************************************/

#ifndef _LONDSEC_H
#define _LONDSEC_H

#ifdef __cplusplus
extern "C" {
#endif

/*---------------------------------------------------------------------------
 *	Import Headers
\*--------------------------------------------------------------------------*/

#ifdef PSX_VERSION
#include "../spec_psx/typedefs.h"
#else
#include "..\specific\stypes.h"
#endif

#include "items.h"

/*---------------------------------------------------------------------------
 *	Prototypes
\*--------------------------------------------------------------------------*/

#if defined(PSX_VERSION) && defined(RELOC)

#define LondSecControl	((VOIDFUNCSINT16 *)Baddie2Ptr)

#else

extern void LondSecControl(sint16 item_number);

#endif

#ifdef __cplusplus
}
#endif

#endif
