/****************************************************************************
*
* MONKEY.H
*
* PROGRAMMER : Gibby
*    VERSION : 00.00
*    CREATED : 20/08/98
*   MODIFIED : 20/08/98
*       TABS : 5
*
* DESCRIPTION
*	Header file for MONKEY.C
*
*****************************************************************************/

#ifndef _MONKEY_H
#define _MONKEY_H

#ifdef __cplusplus
extern "C" {
#endif

/*---------------------------------------------------------------------------
 *	Import Headers
\*--------------------------------------------------------------------------*/

#ifdef PSX_VERSION
#include "../spec_psx/typedefs.h"
#else
#include "..\specific\stypes.h"
#endif

#include "items.h"

/*---------------------------------------------------------------------------
 *	Prototypes
\*--------------------------------------------------------------------------*/

#if defined(PSX_VERSION) && defined(RELOC)

typedef void (MONKEYFUNC1)(ITEM_INFO *);

#define InitialiseMonkey ((VOIDFUNCSINT16*) Baddie2Ptr[0])
#define MonkeyControl ((VOIDFUNCSINT16*) Baddie2Ptr[1])
#define DrawMonkey ((MONKEYFUNC1*) Baddie2Ptr[2])

#else

void InitialiseMonkey(sint16 item_number);
void MonkeyControl(sint16 item_number);
void DrawMonkey(ITEM_INFO *item);

#endif

#ifdef __cplusplus
}
#endif

#endif
