/****************************************************************************
*
* OILRED.H
*
* PROGRAMMER : Gibby
*    VERSION : 00.00
*    CREATED : 20/08/98
*   MODIFIED : 20/08/98
*       TABS : 5
*
* DESCRIPTION
*	Header file for OILRED.C
*
*****************************************************************************/

#ifndef _OILRED_H
#define _OILRED_H

#ifdef __cplusplus
extern "C" {
#endif

/*---------------------------------------------------------------------------
 *	Import Headers
\*--------------------------------------------------------------------------*/

#ifdef PSX_VERSION
#include "../spec_psx/typedefs.h"
#else
#include "..\specific\stypes.h"
#endif

#include "items.h"

/*---------------------------------------------------------------------------
 *	Prototypes
\*--------------------------------------------------------------------------*/
//#define NO_RELOC_OILRED
#if defined(PSX_VERSION) && defined(RELOC) && !defined(NO_RELOC_OILRED)


#define OilRedControl ((VOIDFUNCSINT16*)Baddie3Ptr)

#else

void OilRedControl(sint16 item_number);

#endif

#ifdef __cplusplus
}
#endif

#endif
