/****************************************************************************
*
* OILSMG.H
*
* PROGRAMMER : Gibby
*    VERSION : 00.00
*    CREATED : 20/08/98
*   MODIFIED : 20/08/98
*       TABS : 5
*
* DESCRIPTION
*	Header file for OILSMG.C
*
*****************************************************************************/

#ifndef _OILSMG_H
#define _OILSMG_H

#ifdef __cplusplus
extern "C" {
#endif

/*---------------------------------------------------------------------------
 *	Import Headers
\*--------------------------------------------------------------------------*/

#ifdef PSX_VERSION
#include "../spec_psx/typedefs.h"
#else
#include "..\specific\stypes.h"
#endif

#include "items.h"

/*---------------------------------------------------------------------------
 *	Prototypes
\*--------------------------------------------------------------------------*/

#if defined(PSX_VERSION) && defined(RELOC)

#define InitialiseOilSMG ((VOIDFUNCSINT16*) Baddie2Ptr[0])
#define OilSMGControl ((VOIDFUNCSINT16*) Baddie2Ptr[1])

#else

void InitialiseOilSMG(sint16 item_number);
void OilSMGControl(sint16 item_number);

#endif

#ifdef __cplusplus
}
#endif

#endif
