/****************************************************************************
*
* PUNK.H
*
* PROGRAMMER : Tom
*    VERSION : 00.00
*    CREATED : 23/08/98
*   MODIFIED : 23/08/98
*       TABS : 5
*
* DESCRIPTION
*	Header file for PUNK.C
*
*****************************************************************************/

#ifndef _PUNK_H
#define _PUNK_H

#ifdef __cplusplus
extern "C" {
#endif

/*---------------------------------------------------------------------------
 *	Import Headers
\*--------------------------------------------------------------------------*/

#ifdef PSX_VERSION
#include "../spec_psx/typedefs.h"
#else
#include "..\specific\stypes.h"
#endif

#include "items.h"

/*---------------------------------------------------------------------------
 *	Prototypes
\*--------------------------------------------------------------------------*/

//#define NO_RELOC_PUNK
#if defined(PSX_VERSION) && defined(RELOC) && !defined(NO_RELOC_PUNK)

#define InitialisePunk	((VOIDFUNCSINT16 *)Baddie3Ptr[0])
#define PunkControl		((VOIDFUNCSINT16 *)Baddie3Ptr[1])

#else

extern void InitialisePunk(sint16 item_number);
extern void PunkControl(sint16 item_number);

#endif

#ifdef __cplusplus
}
#endif

#endif
