/****************************************************************************
*
* SHIVA.H
*
* PROGRAMMER : Tom
*    VERSION : 00.00
*    CREATED : 02/06/98
*   MODIFIED : 02/06/98
*       TABS : 5
*
* DESCRIPTION
*	Header file for SHIVA.C
*
*****************************************************************************/

#ifndef _SHIVA_H
#define _SHIVA_H

#ifdef __cplusplus
extern "C" {
#endif

/*---------------------------------------------------------------------------
 *	Import Headers
\*--------------------------------------------------------------------------*/

#ifdef PSX_VERSION
#include "../spec_psx/typedefs.h"
#else
#include "..\specific\stypes.h"
#endif

/*---------------------------------------------------------------------------
 *	Prototypes
\*--------------------------------------------------------------------------*/
//#define NO_RELOC_SHIVA
#if defined(PSX_VERSION) && defined(RELOC) && !defined(NO_RELOC_SHIVA)


typedef void (SHIVAFUNC1)(ITEM_INFO *);
typedef void (SHIVAFUNC2)(ITEM_INFO *, CREATURE_INFO *, int);

#define DrawShiva		((SHIVAFUNC1 *)Baddie1Ptr[0])
#define InitialiseShiva	((VOIDFUNCSINT16 *)Baddie1Ptr[1])
#define ShivaControl	((VOIDFUNCSINT16 *)Baddie1Ptr[2])

#else

extern void DrawShiva(ITEM_INFO *item);
extern void InitialiseShiva(sint16 item_number);
extern void ShivaControl(sint16 item_number);

#endif

#ifdef __cplusplus
}
#endif

#endif
