/****************************************************************************
*
* TONYBOSS.H
*
* PROGRAMMER : Gibby
*    VERSION : 00.00
*    CREATED : 1/09/98
*   MODIFIED : 1/09/98
*       TABS : 5
*
* DESCRIPTION
*	Header file for TONYBOSS.C
*
*****************************************************************************/

#ifndef _TONYBOSS_H
#define _TONYBOSS_H

#ifdef __cplusplus
extern "C" {
#endif

/*---------------------------------------------------------------------------
 *	Import Headers
\*--------------------------------------------------------------------------*/

#ifdef PSX_VERSION
#include "../spec_psx/typedefs.h"
#else
#include "..\specific\stypes.h"
#endif

#include "items.h"
#include "collide.h"

/*---------------------------------------------------------------------------
 *	Prototypes
\*--------------------------------------------------------------------------*/

#if defined(PSX_VERSION) && defined(RELOC) 

typedef void (TONYBOSSFUNC1)(ITEM_INFO *);
//typedef void (TONYBOSSFUNC2)(long, long, long, long, long, long, long);
//typedef void (TONYBOSSFUNC3)(long);

#define InitialiseTonyBoss		((VOIDFUNCSINT16 *)Baddie1Ptr[0])
#define TonyBossControl			((VOIDFUNCSINT16 *)Baddie1Ptr[1])
#define S_DrawTonyBoss			((TONYBOSSFUNC1 *)Baddie1Ptr[2])
#define ControlTonyFireBall		((VOIDFUNCSINT16 *)Baddie1Ptr[3])

#else

extern void InitialiseTonyBoss(sint16);
extern void TonyBossControl(sint16 item_number);
extern void S_DrawTonyBoss(ITEM_INFO *item);
extern void ControlTonyFireBall(sint16 fx_number);

#endif

#ifdef __cplusplus
}
#endif

#endif
