/****************************************************************************
*
* TRAIN.H
*
* PROGRAMMER : Chris
*    VERSION : 00.00
*    CREATED : 11/08/98
*   MODIFIED : 11/08/98
*       TABS : 5
*
* DESCRIPTION
*	Header file for TRAIN.C
*
*****************************************************************************/

#ifndef _TRAIN_H
#define _TRAIN_H

#ifdef __cplusplus
extern "C" {
#endif

/*---------------------------------------------------------------------------
 *	Import Headers
\*--------------------------------------------------------------------------*/

#ifdef PSX_VERSION
#include "../spec_psx/typedefs.h"
#else
#include "..\specific\stypes.h"
#endif

#include "items.h"
#include "collide.h"

/*---------------------------------------------------------------------------
 *	Prototypes
\*--------------------------------------------------------------------------*/

#if defined(PSX_VERSION) && defined(RELOC)

typedef void (TRAINFUNC1)(sint16, ITEM_INFO *, COLL_INFO *);

#define TrainCollision		((TRAINFUNC1 *)Baddie5Ptr[0])
#define TrainControl		((VOIDFUNCSINT16 *)Baddie5Ptr[1])

#else

extern void TrainControl(sint16 train_number);
extern void TrainCollision(sint16 train_number, ITEM_INFO *lara_item, COLL_INFO *coll);

#endif

#ifdef __cplusplus
}
#endif

#endif
