//#define NOKERNEL     	 // KERNEL APIs and definitions
//#define NOGDI             // GDI APIs and definitions
//#define NOUSER            // USER APIs and definitions
#define NOSOUND           // Sound APIs and definitions
#define NOCOMM            // Comm driver APIs and definitions
#define NODRIVERS         // Installable driver APIs and definitions
//#define OEMRESOURCE       // OEM Resource values
#define NONLS             // All NLS defines and routines
#define NOSERVICE         // All Service Controller routines, SERVICE_ equates, etc.
#define NOKANJI           // Kanji support stuff.
//#define NOMINMAX          // min() and max() macros
#define NOLOGERROR        // LogError() and related definitions
#define NOPROFILER        // Profiler APIs
//#define NOMEMMGR          // Local and global memory management
#define NOLFILEIO         // _l* file I/O routines
#define NOOPENFILE        // OpenFile and related definitions
//#define NORESOURCE        // Resource management
#define NOATOM            // Atom management
#define NOLANGUAGE        // Character test routines
//#define NOLSTRING         // lstr* string management routines
#define NODBCS            // Double-byte character set routines
#define NOKEYBOARDINFO    // Keyboard driver routines
#define NOGDICAPMASKS     // GDI device capability constants
//#define NOCOLOR           // COLOR_* color values
//#define NOGDIOBJ          // GDI pens, brushes, fonts
#define NODRAWTEXT        // DrawText() and related definitions
#define NOTEXTMETRIC      // TEXTMETRIC and related APIs
#define NOSCALABLEFONT    // Truetype scalable font support
#define NOBITMAP          // Bitmap support
//#define NORASTEROPS       // GDI Raster operation definitions
#define NOMETAFILE        // Metafile support
//#define NOSYSMETRICS      // GetSystemMetrics() and related SM_* definitions
#define NOSYSTEMPARAMSINFO // SystemParametersInfo() and SPI_* definitions
//#define NOMSG             // APIs and definitions that use MSG structure
//#define NOWINSTYLES       // Window style definitions
//#define NOWINOFFSETS      // Get/SetWindowWord/Long offset definitions
//#define NOSHOWWINDOW      // ShowWindow and related definitions
#define NODEFERWINDOWPOS  // DeferWindowPos and related definitions
//#define NOVIRTUALKEYCODES // VK_* virtual key codes
#define NOKEYSTATES       // MK_* message key state flags
#define NOWH              // SetWindowsHook and related WH_* definitions
#define NOMENUS           // Menu APIs
//#define NOSCROLL          // Scrolling APIs and scroll bar control
#define NOCLIPBOARD       // Clipboard APIs and definitions
#define NOICONS           // IDI_* icon IDs
//#define NOMB              // MessageBox and related definitions
//#define NOSYSCOMMANDS     // WM_SYSCOMMAND SC_* definitions
#define NOMDI             // MDI support
//#define NOCTLMGR          // Control management and controls
//#define NOWINMESSAGES     // WM_* window messages
#define NOHELP            // Help support
#define NOMCX
#define NOIME

#pragma warning (disable: 4201)
