/*********************************************************************************************/
/*                                                                                           */
/* Machine Specific Type Definitions for PSX                                                 */
/*                                                                                           */
/*********************************************************************************************/

#ifndef STYPES_H
#define STYPES_H

#include <sys\types.h>
#include <sys\file.h>
#include <libcd.h>
#include <libpress.h>
#include <libspu.h>
#include <libetc.h>
#include <libgte.h>
#include <libgpu.h>
#include <stdio.h>
#include <asm.h>
#include <kernel.h>
#include <libsn.h>
#include "pad.h"

#include "typedefs.h"
#include "psx_3d.h"
/********************************* TYPE DEFINITIONS ******************************************/

//#define PSX_VERSION


#define DCACHE		0x1f800000
#define DCACHETOP   (DCACHE+0x3f0)

/* Maximum number of frame compensation */
#define MAX_FRAMES 	10
#define S_GOURAUD_COL(r,g,b,s) ((r)|((g)<<8)|((b)<<16))
#define S_COLOUR(r,g,b) ((r)|((g)<<8)|((b)<<16))

/******************************** END OF FILE ************************************************/
#endif
