/****************************************************************************
*
* TYPES.H
*
* PROGRAMMER : Chibsy
*    VERSION : 00.00
*    CREATED : 30/07/97
*   MODIFIED : 30/07/97
*       TABS : 4 8
*
* DESCRIPTION
*	Global data types
*
*****************************************************************************/

#ifndef _TYPES_H
#define _TYPES_H

/*--------------------------------------------------------------------------*
 *		Type Definitions
\*--------------------------------------------------------------------------*/

/* -------- data size definitions */

typedef signed char BYTE;
typedef unsigned char UBYTE;
typedef signed short WORD;
typedef unsigned short UWORD;
typedef signed long LONG;
typedef unsigned long ULONG;


typedef unsigned char uchar;

#ifndef _SYSV_ULONG
	typedef unsigned long ulong;
	#define _SYSV_ULONG
#endif

#ifndef _SYSIII_USHORT
	typedef unsigned short ushort;
	#define _SYSIII_USHORT
#endif

#endif


