/****************************************************************************
*
* BOATINFO.H
*
* PROGRAMMER : Chris
*    VERSION : 00.00
*    CREATED : 08/07/98
*   MODIFIED : 08/07/98
*       TABS : 5
*
* DESCRIPTION
*	Header file for BOAT.C
*
*****************************************************************************/

#ifndef _BOATINFO_H
#define _BOATINFO_H

#ifdef __cplusplus
extern "C" {
#endif

/*---------------------------------------------------------------------------
 *	Import Headers
\*--------------------------------------------------------------------------*/

#ifdef PSX_VERSION
#include "../spec_psx/typedefs.h"
#else
#include "..\specific\stypes.h"
#endif

/*---------------------------------------------------------------------------
 *	Type Definitions
\*--------------------------------------------------------------------------*/

typedef struct {
 	int boat_turn;
	int left_fallspeed, right_fallspeed;
	sint16 tilt_angle, extra_rotation;
	int water, pitch;
	sint16 	prop_rot;
}BOAT_INFO;

#ifdef __cplusplus
}
#endif

#endif
