/****************************************************************************
*
* COMPY.H
*
* PROGRAMMER : Tom
*    VERSION : 00.00
*    CREATED : 02/06/98
*   MODIFIED : 02/06/98
*       TABS : 5
*
* DESCRIPTION
*	Header file for COMPY.C
*
*****************************************************************************/

#ifndef _COMPY_H
#define _COMPY_H

#ifdef __cplusplus
extern "C" {
#endif

/*---------------------------------------------------------------------------
 *	Import Headers
\*--------------------------------------------------------------------------*/

#ifdef PSX_VERSION
#include "../spec_psx/typedefs.h"
#else
#include "..\specific\stypes.h"
#endif

/*---------------------------------------------------------------------------
 *	Prototypes
\*--------------------------------------------------------------------------*/

#if defined(PSX_VERSION) && defined(RELOC)

#define InitialiseCompy ((VOIDFUNCSINT16*) Baddie2Ptr[0])
#define CompyControl ((VOIDFUNCSINT16*) Baddie2Ptr[1])
#define CarcassControl ((VOIDFUNCSINT16 *)Baddie2Ptr[2])

#else

extern void InitialiseCompy(sint16 item_number);
extern void CompyControl(sint16 item_number);
extern void CarcassControl(sint16 item_number);

#endif

#ifdef __cplusplus
}
#endif

#endif
