/****************************************************************************
*
* DIVER.H
*
* PROGRAMMER : Chris
*    VERSION : 00.00
*    CREATED : 10/07/98
*   MODIFIED : 10/07/98
*       TABS : 5
*
* DESCRIPTION
*	Header file for DIVER.C
*
*****************************************************************************/

#ifndef _DIVER_H
#define _DIVER_H

#ifdef __cplusplus
extern "C" {
#endif

/*---------------------------------------------------------------------------
 *	Import Headers
\*--------------------------------------------------------------------------*/

#ifdef PSX_VERSION
#include "../spec_psx/typedefs.h"
#else
#include "..\specific\stypes.h"
#endif

/*---------------------------------------------------------------------------
 *	Prototypes
\*--------------------------------------------------------------------------*/

#if defined(PSX_VERSION) && defined(RELOC)

#define DiverControl ((VOIDFUNCSINT16 *)Baddie1Ptr[0])
#define ControlGhostGasEmitter ((VOIDFUNCSINT16 *)Baddie1Ptr[1])

#else
extern void DiverControl(sint16 item_number);
extern void ControlGhostGasEmitter(sint16 item_number);
#endif

#ifdef __cplusplus
}
#endif

#endif
