/****************************************************************************
*
* INPUT.H
*
* PROGRAMMER : Chris
*    VERSION : 00.00
*    CREATED : 01/06/98
*   MODIFIED : 01/06/98
*       TABS : 5
*
* DESCRIPTION
*	Input definitions
*
*****************************************************************************/

#ifndef _INPUT_H
#define _INPUT_H

#ifdef __cplusplus
extern "C" {
#endif

/*---------------------------------------------------------------------------
 *	Constants
\*--------------------------------------------------------------------------*/

#define IN_FORWARD  1
#define IN_BACK     (1<<1)
#define IN_LEFT     (1<<2)
#define IN_RIGHT    (1<<3)
#define IN_JUMP     (1<<4)
#define IN_DRAW     (1<<5)
#define IN_ACTION   (1<<6)
#define IN_SLOW     (1<<7)
#define IN_OPTION	(1<<8)
#define IN_LOOK	(1<<9)
#define IN_STEPL    (1<<10)
#define IN_STEPR    (1<<11)
#define IN_ROLL	(1<<12)
#define IN_PAUSE	(1<<13)
#define IN_A        (1<<14)        // A to F are Debug thingys..
#define IN_B		(1<<15)
#define IN_C		(1<<16)
#define IN_D		(1<<17)
#define IN_E		(1<<18)
#define IN_F		(1<<19)
#define IN_SELECT	(1<<20)
#define IN_DESELECT	(1<<21)
#define IN_SAVE	(1<<22)
#define IN_LOAD	(1<<23)
#define IN_STEPSHIFT (1<<24)

#define IN_LOOKLEFT	(1<<25)	// Tomb III additions
#define IN_LOOKRIGHT (1<<26)
#define IN_LOOKFORWARD (1<<27)
#define IN_LOOKBACK	(1<<28)
#define IN_DUCK	(1<<29)
#define IN_DASH	(1<<30)

#ifdef __cplusplus
}
#endif

#endif
