/****************************************************************************
*
* LARAELEC.H
*
* PROGRAMMER : Gibby
*    VERSION : 00.00
*    CREATED : 24/08/98
*   MODIFIED : 24/08/98
*       TABS : 5
*
* DESCRIPTION
*	Header file for LARAELEC.C
*
*****************************************************************************/

#ifndef _LARAELEC_H
#define _LARAELEC_H

#ifdef __cplusplus
extern "C" {
#endif

/*---------------------------------------------------------------------------
 *	Import Headers
\*--------------------------------------------------------------------------*/

#ifdef PSX_VERSION
#include "../spec_psx/typedefs.h"
#else
#include "..\specific\stypes.h"
#endif

#include "items.h"

/*---------------------------------------------------------------------------
 *	Prototypes
\*--------------------------------------------------------------------------*/

#if defined(PSX_VERSION) && defined(RELOC)

typedef void (LARAELECFUNC1)(long, ITEM_INFO *);

#define UpdateElectricityPoints ((VOIDFUNCVOID*) Baddie5Ptr[0])
#define LaraElectricDeath	((LARAELECFUNC1*) Baddie5Ptr[1])

#else

void LaraElectricDeath(long copy, ITEM_INFO *item);
void UpdateElectricityPoints();

#endif

#ifdef __cplusplus
}
#endif

#endif
