/****************************************************************************
*
* LARASURF.H
*
* PROGRAMMER : Chris
*    VERSION : 00.00
*    CREATED : 03/06/98
*   MODIFIED : 03/06/98
*       TABS : 5
*
* DESCRIPTION
*	Header file for LARASURF.C
*
*****************************************************************************/

#ifndef _LARASURF_H
#define _LARASURF_H

#ifdef __cplusplus
extern "C" {
#endif

/*---------------------------------------------------------------------------
 *	Import Headers
\*--------------------------------------------------------------------------*/

#include "items.h"
#include "collide.h"

/*---------------------------------------------------------------------------
 *	Constants
\*--------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------
 *	Type Definitions
\*--------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------
 *	Prototypes
\*--------------------------------------------------------------------------*/

extern void LaraSurface(ITEM_INFO *item, COLL_INFO *coll);

#if 0
extern void lara_as_surfswim(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_surfswim(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_as_surfback(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_surfback(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_as_surfleft(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_surfleft(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_as_surfright(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_surfright(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_as_surftread(ITEM_INFO *item, COLL_INFO *coll);
extern void lara_col_surftread(ITEM_INFO *item, COLL_INFO *coll);
#endif

#ifdef __cplusplus
}
#endif

#endif
