/****************************************************************************
*
* MISSILE.H
*
* PROGRAMMER : Chris
*    VERSION : 00.00
*    CREATED : 01/06/98
*   MODIFIED : 01/06/98
*       TABS : 5
*
* DESCRIPTION
*	Header file for MISSILE.C
*
*****************************************************************************/

#ifndef _MISSILE_H
#define _MISSILE_H

#ifdef __cplusplus
extern "C" {
#endif

/*---------------------------------------------------------------------------
 *	Import Headers
\*--------------------------------------------------------------------------*/

#ifdef PSX_VERSION
#include "../spec_psx/typedefs.h"
#else
#include "..\specific\stypes.h"
#endif

#include "effects.h"

/*---------------------------------------------------------------------------
 *	Prototypes
\*--------------------------------------------------------------------------*/

extern void ControlMissile(sint16 fx_number);
extern int ExplodingDeath(sint16 item_number, sint32 mesh_bits, sint16 damage);
extern void ControlBodyPart(sint16 fx_number);
extern void ShootAtLara(FX_INFO *fx);

#ifdef __cplusplus
}
#endif

#endif
