/****************************************************************************
*
* MPGUN.H
*
* PROGRAMMER : Gibby
*    VERSION : 00.00
*    CREATED : 20/08/98
*   MODIFIED : 20/08/98
*       TABS : 5
*
* DESCRIPTION
*	Header file for MPGUN.C
*
*****************************************************************************/

#ifndef _MPGUN_H
#define _MPGUN_H

#ifdef __cplusplus
extern "C" {
#endif

/*---------------------------------------------------------------------------
 *	Import Headers
\*--------------------------------------------------------------------------*/

#ifdef PSX_VERSION
#include "../spec_psx/typedefs.h"
#else
#include "..\specific\stypes.h"
#endif

#include "items.h"

/*---------------------------------------------------------------------------
 *	Prototypes
\*--------------------------------------------------------------------------*/

//#define NO_RELOC_51GUN
#if defined(PSX_VERSION) && defined(RELOC) && !defined(NO_RELOC_51GUN)

#define MPGunControl ((VOIDFUNCSINT16*) Baddie4Ptr[0])

#else

void MPGunControl(sint16 item_number);

#endif

#ifdef __cplusplus
}
#endif

#endif
