/****************************************************************************
*
* RAIN.H
*
* PROGRAMMER : Chris
*    VERSION : 00.00
*    CREATED : 08/07/98
*   MODIFIED : 08/07/98
*       TABS : 5
*
* DESCRIPTION
*	Header file for RAIN.C
*
*****************************************************************************/

#ifndef _RAIN_H
#define _RAIN_H

#ifdef __cplusplus
extern "C" {
#endif

/*---------------------------------------------------------------------------
 *	Import Headers
\*--------------------------------------------------------------------------*/

#ifdef PSX_VERSION
#include "../spec_psx/typedefs.h"
#else
#include "..\specific\stypes.h"
#endif

/*---------------------------------------------------------------------------
 *	Prototypes
\*--------------------------------------------------------------------------*/

#if defined(PSX_VERSION) && defined(RELOC)

#define DoRain()					\
	if (WeatherPtr != NULL)			\
		((VOIDFUNCVOID *)WeatherPtr)()

#else

extern void DoRain();

#endif

#ifdef __cplusplus
}
#endif

#endif
