/****************************************************************************
*
* SWAT.H
*
* PROGRAMMER : Gibby
*    VERSION : 00.00
*    CREATED : 20/08/98
*   MODIFIED : 20/08/98
*       TABS : 5
*
* DESCRIPTION
*	Header file for SWAT.C
*
*****************************************************************************/

#ifndef _SWAT_H
#define _SWAT_H

#ifdef __cplusplus
extern "C" {
#endif

/*---------------------------------------------------------------------------
 *	Import Headers
\*--------------------------------------------------------------------------*/

#ifdef PSX_VERSION
#include "../spec_psx/typedefs.h"
#else
#include "..\specific\stypes.h"
#endif

#include "items.h"

/*---------------------------------------------------------------------------
 *	Prototypes
\*--------------------------------------------------------------------------*/
//#define NO_RELOC_SWAT
#if defined(PSX_VERSION) && defined(RELOC) && !defined(NO_RELOC_SWAT)


#define InitialiseSwat ((VOIDFUNCSINT16*) Baddie6Ptr[0])
#define SwatControl ((VOIDFUNCSINT16*) Baddie6Ptr[1])

#else

void InitialiseSwat(sint16 item_number);
void SwatControl(sint16 item_number);

#endif

#ifdef __cplusplus
}
#endif

#endif
