/****************************************************************************
*
* TONYBOSS.H
*
* PROGRAMMER : Gibby
*    VERSION : 00.00
*    CREATED : 1/09/98
*   MODIFIED : 1/09/98
*       TABS : 5
*
* DESCRIPTION
*	Header file for WILLBOSS.C
*
*****************************************************************************/

#ifndef _WILLBOSS_H
#define _WILLBOSS_H

#ifdef __cplusplus
extern "C" {
#endif

/*---------------------------------------------------------------------------
 *	Import Headers
\*--------------------------------------------------------------------------*/

#ifdef PSX_VERSION
#include "../spec_psx/typedefs.h"
#else
#include "..\specific\stypes.h"
#endif

#include "items.h"
#include "collide.h"

/*---------------------------------------------------------------------------
 *	Prototypes
\*--------------------------------------------------------------------------*/
//#define NO_RELOC_WILLBOSS

#if defined(PSX_VERSION) && defined(RELOC) && !defined(NO_RELOC_WILLBOSS)

typedef void (WILLBOSSFUNC1)(ITEM_INFO *);
//typedef void (TONYBOSSFUNC2)(long, long, long, long, long, long, long);
//typedef void (TONYBOSSFUNC3)(long);

#define InitialiseWillBoss		((VOIDFUNCSINT16 *)Baddie1Ptr[0])
#define WillBossControl			((VOIDFUNCSINT16 *)Baddie1Ptr[1])
#define S_DrawWillBoss			((WILLBOSSFUNC1 *)Baddie1Ptr[2])
#define ControlWillbossPlasmaBall	((VOIDFUNCSINT16 *)Baddie1Ptr[3])

#else

extern void WillBossControl(sint16 item_number);
extern void S_DrawWillBoss(ITEM_INFO *item);
extern void InitialiseWillBoss(sint16);
extern void ControlWillbossPlasmaBall(sint16 fx_number);

#endif

#ifdef __cplusplus
}
#endif

#endif
