/****************************************************************************
*
* FILE.H
*
* PROGRAMMER : Chris
*    VERSION : 00.00
*    CREATED : 04/06/98
*   MODIFIED : 04/06/98
*       TABS : 5
*
* DESCRIPTION
*	Header file for FILE.C
*
*****************************************************************************/

#ifndef _FILE_H
#define _FILE_H

/*---------------------------------------------------------------------------
 *	Import Headers
\*--------------------------------------------------------------------------*/

#include "typedefs.h"

/*---------------------------------------------------------------------------
 *	Constants
\*--------------------------------------------------------------------------*/

//#define EZORAY

/*---------------------------------------------------------------------------
 *	Prototypes
\*--------------------------------------------------------------------------*/

extern int FILE_Load(char *szFileName, void* pDest);
extern int FILE_Save(char* szFileName,void* pSrc,uint32 dwLength);
extern uint32 FILE_Length(char* szFileName);
extern int FILE_Open(char* szFileName);
extern int FILE_Read(void* pDest,int nItemSize,int nItems,int nHandle);
extern void FILE_Close(int nHandle);
extern void RelocateModule(uint32 Module, uint32 *RelocData);

#ifdef EZORAY
extern int PCopen0(char *name, int flags, int perms);
extern int PCcreat0(char *name, int perms);
extern int PClseek0(int fd, int offset, int mode);
extern int PCread0(int fd, char *buff, int len);
extern int PCwrite0(int fd, char *buff, int len);
extern int PCclose0(int fd);
#endif

#endif
