/****************************************************************************
*
* PICTURE.H
*
* PROGRAMMER : Chris
*    VERSION : 00.00
*    CREATED : 04/06/98
*   MODIFIED : 04/06/98
*       TABS : 5
*
* DESCRIPTION
*	Header file for PICTURE.C
*
*****************************************************************************/

#ifndef _PICTURE_H
#define _PICTURE_H

/*---------------------------------------------------------------------------
 *	Import Headers
\*--------------------------------------------------------------------------*/

#include "typedefs.h"

/*---------------------------------------------------------------------------
 *	Constants
\*--------------------------------------------------------------------------*/

#define FADE_MIN (24<<16)
#define FADE_MID (22<<16)
#define FADE_MAX (16<<16)

/*---------------------------------------------------------------------------
 *	Prototypes
\*--------------------------------------------------------------------------*/

extern char fades_enabled;

extern void S_CopyScreenToBuffer();
extern void S_DrawPic();
extern void S_DisplayPictureBuffer(void);
extern void S_InitFade(int nSource,int nDest,int tCopyBuf);
extern void S_FadeToBlack();
extern void S_FadeUp();
extern void S_WaitFade(void);
extern sint32 S_DisplayPicture(char *szFileName);
extern sint32 S_DisplayPictureMem(char *pPacked);
extern int S_ShowPicture(char *fname, int frames, int quitable);
extern int S_ShowPictureMem(char *addr, int frames, int quitable);
extern void PIC_PirateScreen(char *fname);

#endif
