#include "stypes.h"
#include "..\game\items.h"
#include "..\game\room.h"
#include "include.h"

/*** globals ***/
#ifdef GAMEDEBUG
int maxot = 0;
int num0=0,num1=0,num2=0;
int onum0=0,onum1=0,onum2=0;
#endif

sint32 ls_adder;
sint32 ls_divider;

sint32 phd_left;						// Left Clipping Value
sint32 phd_right;						// Right Clipping Value
sint32 phd_top;							// Top Clipping Value
sint32 phd_bottom;						// Bottom Clipping Value
sint32 phd_persp;						// perspective thang
sint32* phd_mxptr;						// matrix pointer....

sint32 w2v_matrix[12];					// Copy Of W2V matrix...
sint32 matrix_stack[MAX_MATRICES*12];	// matrix stack..

PHD_VECTOR ls_vector_view;				// light vector in View Frame
PHD_ANGLE phd_ls_pitch,phd_ls_yaw;		// Angles Of Any Light Source

PSXTEXTSTRUCT* psxtextinfo=NULL;		// Texture information..
PSXSPRITESTRUCT* psxspriteinfo=NULL;	// Sprite information..

sint32 phd_winxmax;						// Maximum Window X coord           // NOW DEFINED AS CONSTANTS!!! (or are they...)
sint32 phd_winwidth;					// Window Width
sint32 phd_centerx;						// Vanishing point X
sint32 phd_scrwidth;					// Width of Screen In Pixels

//sint32 phd_winymax;					// Maximum Window Y coord
//sint32 phd_winheight;					// Window Height
//sint32 phd_centery;					// Vanishing point Y
//sint32 phd_znear;						// Distance to near clip plane in View.Frame
//sint32 phd_zfar;						// Distance to far clip plane in View.Frame
//sint32 phd_viewdist;					// Distance you can see in World.Frame
