#ifndef _TYPEDEFS_H_INCLUDED
#define _TYPEDEFS_H_INCLUDED

#define GAMEDEBUG
//#define RELOC

typedef unsigned char	uint8;
typedef signed char		sint8;
typedef unsigned short	uint16;
typedef signed short	sint16;
typedef unsigned long	uint32;
typedef signed long		sint32;
typedef char			bool;

#ifndef NULL
#define NULL ((void*)0)
#endif

#ifndef FALSE
#define FALSE 0
#endif

#ifndef TRUE
#define TRUE 1
#endif

#ifdef GAMEDEBUG
#define DebugOut(args...) printf(args)
#else
#define DebugOut(args...)
#endif

typedef void (VOIDFUNCVOID)(void);
typedef void (VOIDFUNCSINT16)(sint16);

#endif
